#include <stdlib.h>
#include <string.h>
#include "fileserv.h"

char *
catfile_n(char const *dir, size_t len, char const *file)
{
	size_t sz;
	char *p;
	
	sz = len;
	if (sz > 0 && dir[sz-1] != '/')
		sz++;
	if (*file == '/')
		file++;
	sz += strlen(file);
	p = xmalloc(sz + 1);
	memcpy(p, dir, len);
	if (p[len-1] != '/')
		p[len++] = '/';
	strcpy(p + len, file);
	return p;
}

char *
catfile(char const *dir, char const *file)
{
	return catfile_n(dir, strlen(dir), file);
}
